//+------------------------------------------------------------------+
//|                                                    Trend WPR.mq4 |
//|                      Copyright  2007, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window

extern int     PeriodWPR=8;
extern double  CriteriaWPR=25;
extern int     ATRPeriod=40;
extern double  kATR=0.5;

//**********************************************************************************
int init()
  {
   return(0);
  }
//**********************************************************************************
int deinit()
  {
//----
ObjectsDeleteAll(0, EMPTY);   
//----
   return(0);
  }
//**********************************************************************************
int start()
  {
         string  Pa3="Trend WPR  M5 " +TrendByWPR(1)+" M15 " +TrendByWPR(2)+" M30 " +TrendByWPR(3)+" H1 " +TrendByWPR(4)+" H4 " +TrendByWPR(5);  
         ObjectCreate("TrendWPR", OBJ_LABEL, 0, 0, 0);
         ObjectSet("TrendWPR", OBJPROP_CORNER, 0);
         ObjectSet("TrendWPR", OBJPROP_XDISTANCE, 5);
         ObjectSet("TrendWPR", OBJPROP_YDISTANCE, 125);
         ObjectSetText("TrendWPR", Pa3, 7, "Verdana",DodgerBlue);   
   return(0);
  }
//**********************************************************************************
int TrendByWPR(int period_counter)
  {
//----
   int res=0;
   int PeiodMinute=PeriodNumber(period_counter);
   int curPos,LastUpPos,PreLastUpPos,LastDownPos,PreLastDownPos,LastPeak,newPos;
   bool FindUp=true,FindDown=true,SearchCompleted=false;
   double CurWPR=iWPR(NULL,PeiodMinute,PeriodWPR,0);
//----
   //=======   -      
   if (CurWPR<=CriteriaWPR-100)
      {
      FindDown=false;
      LastPeak=0;
      }   
   if (CurWPR>=-CriteriaWPR)
      {
      FindUp=false;
      LastPeak=0;
      }   
   // ================     -
   while(!SearchCompleted && curPos<Bars)
      {
      if (iWPR(NULL,PeiodMinute,PeriodWPR,curPos)>=-CriteriaWPR && LastPeak<0)
         {
         FindUp=false;
         LastPeak=curPos;
         curPos++;
         continue;
         }
         
      if (iWPR(NULL,PeiodMinute,PeriodWPR,curPos)<=CriteriaWPR-100 && LastPeak<0)
         {
         FindDown=false;
         LastPeak=curPos;
         curPos++;
         continue;
         }
         
      if (iWPR(NULL,PeiodMinute,PeriodWPR,curPos)>=-CriteriaWPR && FindUp)
         {//   
         newPos=curPos; 
         while(iWPR(NULL,PeiodMinute,PeriodWPR,curPos)>CriteriaWPR-100 && curPos<Bars)
            {//    ,      
            curPos++;
            }
         if (LastUpPos==0) 
            {
            LastUpPos=iHighest(NULL,PeiodMinute,MODE_HIGH,curPos-LastPeak,LastPeak);   
            LastPeak=LastUpPos;
            }
         else 
            {
            PreLastUpPos=iHighest(NULL,PeiodMinute,MODE_HIGH,curPos-LastPeak,LastPeak);
            LastPeak=PreLastUpPos;
            }
         curPos=newPos;
         FindUp=false;
         FindDown=true;
         curPos++;
         continue;
         }//==============
 
      if (iWPR(NULL,PeiodMinute,PeriodWPR,curPos)<=CriteriaWPR-100 && FindDown)
         {
         newPos=curPos; 
         while(iWPR(NULL,PeiodMinute,PeriodWPR,curPos)<-CriteriaWPR && curPos<Bars)
            {
            curPos++;
            }
         if (LastDownPos==0) 
            {
            LastDownPos=iLowest(NULL,PeiodMinute,MODE_LOW,curPos-LastPeak,LastPeak);
            LastPeak=LastDownPos;
            }   
         else 
            {
            PreLastDownPos=iLowest(NULL,PeiodMinute,MODE_LOW,curPos-LastPeak,LastPeak);
            LastPeak=PreLastDownPos;
            }
         curPos=newPos;
         FindDown=false;
         FindUp=true;
         curPos++;
         continue;
         }
      if (PreLastDownPos!=0 && PreLastUpPos!=0) SearchCompleted=true;
      curPos++;
      }

      /*Comment("LastUpPos       ",LastUpPos,
              "\nPreLastUpPos    ",PreLastUpPos,
              "\nLastDownPos     ",LastDownPos,
              "\nPreLastDownPos  ",PreLastDownPos,
              "\n           ",TimeToStr(CurTime()));*/
    // SetUpArrows(LastUpPos,PreLastUpPos,LastDownPos,PreLastDownPos);
  
  if (High[LastUpPos]-High[PreLastUpPos]>=kATR*iATR(NULL,PeiodMinute,ATRPeriod,LastUpPos)
    &&Low[LastDownPos]>Low[PreLastDownPos]) res=1;     
  if (Low[PreLastDownPos]-Low[LastDownPos]>=kATR*iATR(NULL,PeiodMinute,ATRPeriod,LastDownPos)
    &&High[PreLastUpPos]>High[LastUpPos]) res=-1;    
   
   return(res);
  }
//**********************************************************************************  
int PeriodNumber(int number)
   {
   int per_min;
   switch (number)
      {
      case 1: per_min=PERIOD_M5;break;
      case 2: per_min=PERIOD_M15;break;
      case 3: per_min=PERIOD_M30;break;
      case 4: per_min=PERIOD_H1;break;
      case 5: per_min=PERIOD_H4;break;
      }
   return(per_min);   
   } 
//**********************************************************************************  
 